/*** Counseling Appointments ***********************
Connie is a counselor at OHS (Our High School).  
Connie meets students individually throughout the day.
Each morning students ask her secretary for an appointment,
and the secretary writes the name on a sheet of paper at the
appropriate time.  They want to use a computer program instead
of paper, so that the data can appear on both the secretary's
and the counselor's computer screen.  So they need a way to
record names in "boxes", like they do on the paper.

The following program uses an ARRAY to simulate these boxes.
It contains a cell (box) for each minute in the day,
from 0 to 2399.  It includes cells for non-real times, like 1199.
****************************************************/

String[] names = new String[2400];  // from 0:00 until 24:00

void setup()
{
  String name = "";
  do
  {
    name = input("Name");
    if(name.equals("ABORT")){ System.exit(0); }  // end the program
    int time = int(input("Time code (e.g. 840 or 1200)"));
    names[time] = name;
    showAllNames();
  } while(true);        // loop never ends
}

void showAllNames()     // shows all the times where there is a name
{
   for(int t = 0; t < 2400; t=t+1)
   {
     String name = names[t];
     if(name!=null)
     {
       println(t + "\t" + name);  
     }
   }  
   println("================");
}

public String input(String prompt)
{ return javax.swing.JOptionPane.showInputDialog(null,prompt); }

/*** Improvements Needed ************************************
This needs lots of improvements:
- it's easy to make a mistake and overwrite one name with a different one
- incorrect time numbers, like 1080, should be rejected
- the output only appears on the secretary's screen, not the counselors
- if the computer stops, all data will be lost - it needs to be saved
*************************************************************/
