/*******************************************
Stew Dent is a student at OHS (Our High School).
Stew is exploring a probability puzzle - that in a
group of 24 students, there is a probability over
50% that at least 2 of them share the same birthday.
To explore this puzzle, he asked students to type
their birthday into a computer program.  For this to
function, the birthdays must all be in the same format,
so matches can be detected.  This program inputs birthdates
and attempts to store them in the common format MMM DD.
********************************************/
import java.util.*;

public class Birthdates
{
  Vector birthDates = new Vector();
  int count = 0;
  
  public Birthdates()
  {
    while(true)                                   // loop forever
    {
      String bd = input("Type your birthdate as MMM DD");
      String fixed = fix(bd);
      if(fixed.equals(""))          // bad dates return "" error code
      {
        output(bd + " is not valid - it has been rejected."); 
      }
      else
      {
        count = count + 1;
        if(birthDates.contains(fixed))
        {
          output("Duplicate birthdate after " + count + " inputs");
          System.exit(0);
        }
        else
        {
          birthDates.add(fixed); 
          System.out.println(fixed);
        }
      }
    }  
  }
  
  String fix(String bd)  // attempts to convert date to MMM DD format
  {
    bd = bd.toUpperCase();
    int space = bd.indexOf(" ");
    if(space < 0)
    { return ""; }     // blank space is missing
    if(space < 3)      // check for "3 Apr" or "03 Apr"
    {
      bd = bd.substring(space+1) + " " + bd.substring(0,space); 
    }
    String month = bd.substring(0,3);
    String date = bd.substring(4);
    int d = Integer.parseInt(date);               
    if(d <= 0 || d > 31)
    { return ""; }                   // date is not valid
    String mlist = "JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC";
    if(mlist.indexOf(month) < 0)
    { return ""; }                   // name of month not valid
    bd = month + " " + d;
    return bd; 
  }
  
  public static void main(String[] args)
  {  new Birthdates();  }
  
  public String input(String prompt)
  { return javax.swing.JOptionPane.showInputDialog(null,prompt); }
  
  public void output(String message)
  {  javax.swing.JOptionPane.showMessageDialog(null,message);  }
}