/************************************************************************\
PICTURES and BUTTONS

This demo program shows how to do all the following:
(1) place AWT Button controls on the the programs form window
(2) respond to Button clicks - the action method
(3) display an image in a pop-up window
\************************************************************************/

import java.awt.*;
import javax.swing.*;

public class ButtonPics extends Frame
{
  Button b1 = new Button("Pop-up Picture");
  Button b2 = new Button("Quit");
  Font big = new Font("Arial",0,36);
  
  public ButtonPics()
  {
    setBounds(100,100,600,400);       // change size of standard window
    setLayout(new FlowLayout());
    b1.setFont(big);     // change font on the Button b1
    b2.setFont(big);     // change font on Button b2
    add(b1);             // display Button b1
    add(b2);             // display Button b2
  }
 
  public boolean action(java.awt.Event evt, Object src)
  {
    Object source = evt.target;      // this is the Button that was clicked
    
    if(source==b1)
    {
      // picture file must be stored on the disk drive
      // the path below only works in Windows    
      PictureFrame pf2 = new PictureFrame(
           "http://www.dltk-kids.com/crafts/circus/images/s/mclown.jpg");
      pf2.setBounds(150,150,600,400);
    }
    
    if(source==b2)
    {
       System.exit(0); 
    }
    
    return true;
  }
  
  class PictureFrame extends JFrame   // a class to create a popup
  {                                   // window showing a picture
    JLabel pic;                      // can be a URL or a disk path
    
    public PictureFrame(String name) 
    {
      try
      {
        setVisible(true);
        Icon ii = new ImageIcon(new java.net.URL(name)); 
        pic = new JLabel("",ii,JLabel.LEFT);
        pic.setSize(600,400);
        this.getContentPane().add(pic);
      }
      catch(Exception ex)
      { } 
    } 
  }
  
  public static void main(String[] args)
  {  (new ButtonPics()).setVisible(true); }
}