
/**
 * **********************************************
 * Dan is in charge of the school's Halloween dance. He stands at the entrance
 * and records the names of people when they arrive. When they leave, he crosses
 * out the name. So at any given time, he has a list of people in the room. If
 * someone leaves temporarily, to fetch something, their name is crossed out and
 * then added again when they re-enter. This program uses a VECTOR to maintain a
 * list of names, replacing the paper list.
 * ***********************************************
 */
import java.util.*;

public class DanceVector {

   Vector names = new Vector();

   public DanceVector() {
      while (true) // this loop runs forever
      {
         String n = input("Name");
         if (n.equals("quit")) {
            System.exit(0);
         }     // type "quit" to end the program
         if (names.contains(n)) {
            String ok = input(n + " is leaving? (Y/N)");
            if (ok.equals("Y") || ok.equals("y") || ok.equals("")) {
               names.remove(n);
            }
         } else {
            names.add(n);
         }
         printAll();
      }
   }

   void printAll() {
      Iterator iter = names.listIterator();

      while (iter.hasNext()) {
         System.out.println(iter.next());
      }
      System.out.println("============");
   }

   public String input(String prompt) {
      return javax.swing.JOptionPane.showInputDialog(null, prompt);
   }

   public void output(String message) {
      javax.swing.JOptionPane.showMessageDialog(null, message);
   }

   public static void main(String[] args) {
      new DanceVector();
   }
}
