import java.awt.*;
import java.util.*;

App gui = new App();

void setup()
{
   size(500,400);
   textFont(createFont("Arial",32));   
   // font for TEXT commands
   new Box("First",100,10,100,30,255,200,200);
   new Box("Second",200,10,100,30,200,255,200);
   new Box("  ",300,10,100,30,200,200,255);

   System.out.println(boxes.size());
}

void draw()
{  
   background(224); 
   
   showBoxes();
   
   if(gui.clicks == 0)
   {
      fill(0,0,255);
      text("WELCOME",150,100);
      text("Click [GO] in the other window",20,150);
      strokeWeight(10);
      for(int c = 0; c<7; c = c + 1)
      {
        stroke(255-c*30,c*35,128);
        line(20,200+30*c,450,200+30*c);
      }
   }
   else if(gui.clicks < 7 && gui.clicks > 0)
   {
      PImage dice = loadImage(gui.clicks+".jpg");
      image(dice,50,50,300,300);     
   }
   else if(gui.clicks == 7)
   {
      PImage clown = loadImage("clown.jpg");
      image(clown,50,50,400,300);
   }
   else if(gui.clicks == 8)
   {  gui.clicks = 9;
      gui.counter.setText(gui.clicks+"");
      gui.output("Bye bye"); 
   }
   else if(gui.clicks == 9)
   {
      text("One more [GO] click",50,200); 
   }
   else if(gui.clicks > 9)
   {
      PImage clown = loadImage("monkeys.jpg");
      image(clown,50,50,400,300);     
   }   
}
void mouseClicked()
{
   checkBoxes();
   
   if(clickedBox("First"))
   {
      output("1st");
      resetBox("First");
   }
   
   if(clickedBox("Second"))
   {
      output(boxes.get(0).inclick);
      resetBox("Second");
   }
   
   if(clickedBox("  "))
   {
      output("..secret..");
      resetBox("  ");
   }
   
   if( gui.clicks == 7)
   {
      if(mouseOver(220,150,320,220))
      {
         output("OWWWEEEEE!"); 
      }
   }
}  
  

//====== AWT GUI App below ===========================//

class App extends GUI
{
   Button go = addButton("Go",50,50,100,50,this);
   Button stop = addButton("Stop",200,50,100,50,this);
   Label counter = addLabel("",100,100,100,50,this);
   int clicks = 0;
   
   public App()
   {
      super(400,400); 
      setBounds(600,100,400,400);
      counter.setFont(new Font("Arial",0,36));
      go.setFont(new Font("Arial",2,24));
      stop.setFont(new Font("Courier",1,24));
   }
   
   public void actions(Object source,String command)
   {
      if(source == go)
      { 
         clicks=clicks+1;
         counter.setText(clicks+"");
      }
      if(source == stop)
      {
         System.exit(0); 
      }
   }
}