PFont boxFont = createFont("Arial",24);

Vector<Box> boxes = new Vector();

void showBoxes()
{
   for(Box b : boxes)
   {
      b.show();
   }
}

void checkBoxes()
{
   for(Box b : boxes)
   {
      b.checkClicked();
   }  
}

void resetBox(String s)
{
   for(Box b : boxes)
   {
      if(b.tex.equals(s))
      {  b.inclick = false; }
   }   
}

boolean clickedBox(String s)
{
   for(Box b : boxes)
   {
      if(b.tex.equals(s))
      {  if(b.inclick)
         { return true; }
         else
         {return false;}
      }
   }   
   return false;
}

class Box
{
    String tex = "";
    int left, top, width, height, red, green, blue;
    boolean inclick = false;
  
    public Box(String tex,int left, int top, int width, int height,
                 int red, int green, int blue)
    {
       this.tex = tex;
       this.left = left;
       this.top = top;
       this.width = width;
       this.height= height;
       this.red = red;
       this.green = green;
       this.blue = blue;
       boxes.add(this);
    }
    
    boolean mouseover()
    {
       return mouseOver(left,top,left+width,top+height);
    }
    
    void show()
    {
       if(mouseover())
       {
          fill(255);
       }
       else
       {
          fill(red,green,blue);
       }
       noStroke();
       rect(left,top,width,height);
       textFont(boxFont);
       fill(0,0,0);
       text(tex,left+5,top+height-5);
    }
    
    boolean checkClicked()
    {
       if(inclick==false && mouseover() )
       {  inclick = true;
          return true;
       }
       else
       { inclick = false; 
         return false;
       }
       
    }
}

boolean mouseOver(int x1,int y1,int x2,int y2)
{
   if(mouseX >= x1 && mouseX <= x2 && mouseY >= y1 && mouseY <= y2)
   {
      return true; 
   }
   else
   {  return false; }
}

 //===========================================================
 //=== IBIO simplified input/output commands - GUI version ===
 //===========================================================


   public void outputString(String message)
   {  output(message);  }

   public void output(char info)
   {  output(info + ""); }

   public void output(byte info)
   {  output(info + ""); }

   public void output(int info)
   {  output(info + ""); }

   public void output(long info)
   {  output(info + ""); }

   public void output(double info)
   {  output(info + ""); }

   public void output(boolean info)
   {  output(info + ""); }

   //----- Numerical input methods return 0 on error ------------

   public String inputString(String prompt)
   { return input(prompt);  }

   public String input()
   { return input("");     }

   public char inputChar(String prompt)
   { char result=(char)0;
     try{result=input(prompt).charAt(0);}
     catch (Exception e){result = (char)0;}
     return result;
   }

   public byte inputByte(String prompt)
   { byte result=0;
     try{result=Byte.valueOf(input(prompt).trim()).byteValue();}
     catch (Exception e){result = 0;}
     return result;
   }

   public int inputInt(String prompt)
   {  int result=0;
      try{result=Integer.valueOf(
                        input(prompt).trim()).intValue();}
      catch (Exception e){result = 0;}
      return result;
   }

   public long inputLong(String prompt)
   {  long result=0;
      try{result=Long.valueOf(input(prompt).trim()).longValue();}
      catch (Exception e){result = 0;}
      return result;
   }

   public double inputDouble(String prompt)
   {  double result=0;
      try{result=Double.valueOf(
                          input(prompt).trim()).doubleValue();}
      catch (Exception e){result = 0;}
      return result;
   }

   public boolean inputBoolean(String prompt)
   {  boolean result=false;
      try{result=Boolean.valueOf(
                         input(prompt).trim()).booleanValue();}
      catch (Exception e){result = false;}
      return result;
   }
  //============================================================
  //=========== end IBIO =======================================
  //============================================================
  
  Object big = bigFonts();

public String input(String prompt)
{ return javax.swing.JOptionPane.showInputDialog(null,prompt); }

public void output(String message)
{ javax.swing.JOptionPane.showMessageDialog(null,message); }

public Object bigFonts()
{
javax.swing.UIManager.put(
"OptionPane.messageFont",
new javax.swing.plaf.FontUIResource(new java.awt.Font("Verdana", java.awt.Font.BOLD, 24))
);

javax.swing.UIManager.put(
"OptionPane.buttonFont",
new javax.swing.plaf.FontUIResource(new java.awt.Font("Verdana", java.awt.Font.BOLD, 24))
);

javax.swing.UIManager.put(
"TextField.font",
new javax.swing.plaf.FontUIResource(new java.awt.Font("Verdana", java.awt.Font.BOLD, 16))
);

return null;
}
 