/***********************************************
Libby is the librarian at OHS.  She must type ISBN book numbers
into her database, and she occasionally makes mistakes.  She asked
programmer Pete if he could write a program to check the ISBN
numbers and reject obvious mistakes, like too few digits or
a mismatched check digit.  Pete read the following web-page
http://isbn-information.com/10-digit-isbn.html
and then wrote the following test program.  It expects the user to type
10 digits (the last might be X), without any dashes or spaces.
This is only a first attempt - it won't really solve Libby's problem,
as this could needs to be incorporated into Libby's database program.
************************************************/

void setup()
{
  String code = input("Type an ISBN numbers - no dashes or spaces");
  code = code.toUpperCase();
  System.out.println(code);
  if(code.length()!=10)                                 // check length = 10
  { System.out.println("Not valid - need exactly 10 characters");
    System.exit(0);
  }
  int sum = 0;
  for(int p = 0; p < 10; p = p+1)                // count through characters
  {
    char c = code.charAt(p);
    if( c < '0' || (c > '9' && c != 'X') )       // check if not digit or X
    { System.out.println("Invalid character : " + c); 
      System.exit(0);
    }
    int val;                                     // value of the character
    if(c == 'X') { val = 10; }
    else { val = (int)c - 48;}                   // convert ASCII code to value
    sum = sum + val * (10-p);
  }
  if(sum % 11 != 0)                         // check-sum must be divisible by 11
  {
    System.out.println("Check-sum is not divisible by 11, so incorrect");
    System.exit(0);
  }
  System.out.println("Valid");
}

public String input(String prompt)
{ return javax.swing.JOptionPane.showInputDialog(null,prompt); }
 
public void output(String message)
{  javax.swing.JOptionPane.showMessageDialog(null,message);  }
