class Time
{
   int hour = 0;
   int min = 0; 
}

Time start = new Time();
Time finish = new Time();

void setup()
{
   start.hour = 8;
   start.min = 30;
   finish.hour = 12;
   finish.min = 50;
   
   int hours = finish.hour - start.hour;
   int minutes = finish.min - start.min;
   
   int totalMinutes = hours*60 + minutes;
   
   println("Start = " + start.hour + ":" + start.min);
   println("Finish= " + finish.hour + ":" + finish.min);
   println("Elapsed = " + totalMinutes + " minutes");
}

/*****************************

== ELAPSED TIME ==

This program contains the START time for school,
as well as the FINISH time.  It then calculates
the TOTAL-MINUTES for the school day.

The program uses a TIME CLASS to store a pair
of numbers for the HOUR:MIN.  Then there are two TIME
variables called START and FINSISH. The alternative is to
have separate variables for startHour and finishHour:
   
   int startHour = 8;
   int startMin = 30;
   int finishHour = 12;
   int finishMin = 50;
   
For a VERY SIMPLE program like this one, using 
individual variables works fine.  For larger programs,
that might store hundreds of times - say all the 
take-off and landing times for all the flights 
in an airport for one day - it is not feasible to
use individually named variables for every piece of data.

== TESTING ==

It's not clear that the ALGORITHM for calculating elapsed time,
as shown above, actually works correctly all the time.
What happens for times like  8:30 to 12:00 ?
Then finish.min - start.min is a negative number.
Does a negative number cause any problems when calculating minutes?
A fair bit of testing is required to guarantee correctness.
Try changing the program to do the following TEST CASES
and confirm that the program does print a correct result.

 START   FINISH   CORRECT RESULT
  8:30    12:50     260
  8:30    12:00     210
  8:30     9:30      60
  8:45     8:50       5
  8:45     8:30     -15  strange, but correct
  8:45     8:45       0
  0:00    23:59    1439
 23:59     0:01       2 minutes? Or negative -1438?

== BETTER PROGRAM ==

Now change the program to do something more interesting.
Starting with a START time and a FINISH time,
calculate the clock time that is in the middle of the day.
For example:

  8:30 - 12:30   middle time is 10:30
  8:30 - 15:10   middle time is 400 minutes,
                 so the middle time happens after 200 min,
                 which is 3 hours and 20 minutes,
                 so it happens at 11:50 .

******************************/
