/****************************************
Matt is obsessed with math.  He heard about Goldbach's 
conjecture, which says that every even number can be
written as the sum of two prime numbers.  For example:
100 = 11 + 89 .  But it's difficult to find the primes
for a large number like a million.  Matt wrote this program
that makes a list of prime numbers up to 1 million,
and then uses the list to solve Golbach for large numbers.
*****************************************/

int[] primes = new int[1000000];  // defaults to all zeroes

void setup()
{
   calculatePrimes(); 
   int num = 0;
   do
   {
     num = int(input("Type a large even number"));
     searchForPrimes(num); 
   } while(num != 0);      // input 0 to end the program
}

void calculatePrimes()     // sieve of Eratosthenes
{
   primes[0] = 1;
   primes[1] = 1;
   for(int n = 2; n < 1000000; n = n+1)
   {
       int c = 2*n;
       while(c < 1000000)
       {
         primes[c] = 1;   // 1 indicates NOT prime
         c=c+n;
       } 
   } 
}

void searchForPrimes(int num)
{
   for(int x=3; x < num; x = x+2)
   {
      int p = num - x;
      if( primes[x] == 0 && primes[p] == 0)
      {
         println(num + " = " + x + " + " + p); 
      }
   }
}

public String input(String prompt)
{ return javax.swing.JOptionPane.showInputDialog(null,prompt); }
 
public void output(String message)
{  javax.swing.JOptionPane.showMessageDialog(null,message);  }
