//==== Quick IO Routines, Dave Mulkey, 2014 =============
import java.awt.*;

void add(java.awt.Component comp,int x,int y,int w,int h)
{
   setLayout(null);
   comp.setBounds(x,y,w,h);
   this.add(comp); 
}

Button addButton(String text,int x,int y,int w,int h)
{
   setLayout(null);
   Button comp = new Button(text);
   comp.setBounds(x,y,w,h);
   this.add(comp); 
   return comp;
}  

Checkbox addCheckbox(String text,int x,int y,int w,int h)
{
   setLayout(null);
   Checkbox comp = new Checkbox(text);
   comp.setBounds(x,y,w,h);
   this.add(comp); 
   return comp;   
}

TextField addTextField(String text,int x,int y,int w,int h)
{
   setLayout(null);
   TextField comp = new TextField(text);
   comp.setBounds(x,y,w,h);
   this.add(comp); 
   return comp;   
}

Label addLabel(String text,int x,int y,int w,int h)
{
   setLayout(null);
   Label comp = new Label(text);
   comp.setBounds(x,y,w,h);
   this.add(comp); 
   return comp;   
}

TextArea addTextArea(String text,int x,int y,int w,int h)
{
   setLayout(null);
   TextArea comp = new TextArea(text);
   comp.addKeyListener(this);
   comp.setBounds(x,y,w,h);
   this.add(comp); 
   return comp;   
}

  public List addList(String words,int left, int top, int width, int height)
  {
       List newComp = new List();
       while (words.length()>0)
       { int s = words.indexOf("|");
         if (s<0)
         { newComp.add(words);
           words = "";
         }
         else
         { newComp.add(words.substring(0,s));
           words = words.substring(s+1);
         }
       }
       this.add(newComp);
       newComp.setBounds(left,top,width,height);
       return newComp;
  }


   public Choice addChoice(String words,int left, int top, int width, int height)
   {
       Choice newComp = new Choice();
       while (words.length()>0)
       { int s = words.indexOf("|");
         if (s<0)
         { newComp.add(words);
           words = "";
         }
         else
         { newComp.add(words.substring(0,s));
           words = words.substring(s+1);
         }
       }
       this.add(newComp);
              newComp.setBounds(left,top,width,height);
       return newComp;
   } 
  
   
//==== Utility methods ============================

  public Process runProgram(String programName)
  {
      String os = System.getProperty("os.name").substring(0,3); 
      if(os.equals("Mac"))
      {  programName = "open " + programName; }
         Process handle = null;
         try
         { handle = Runtime.getRuntime().exec(programName);
         }
         catch(IOException ex)
         { };
         return handle;
  }

  public String chooseFile()
  { 
    FileDialog fd = new FileDialog(new java.awt.Frame());
    fd.setVisible(true);
    return fd.getDirectory() + fd.getFile();
  }
  
  public void showFile(String fileName)
  {
      String os = System.getProperty("os.name").substring(0,3); 
      if(os.equals("Win"))
      {
         try{
           runProgram("explorer " + fileName);
         }
         catch(Exception ex)
         {
            System.out.println(ex.toString());  
         }
      }    
      if(os.equals("Mac") || os.equals("Lin"))
      {
           try{
             Runtime.getRuntime().exec(
                new String[]{"/usr/bin/open",
                             fileName}
                             );
            }
            catch(Exception ex)
            {  System.out.println(ex.toString()); }
      }    
      
  }

  public String getType(Object ob)
  {
     String c = ob.getClass().toString();
     int p = c.lastIndexOf(".");
     if (p<0) {p=-1;}
     return c.substring(p+1);
  }
  
  public String dataPath()
  {
     return sketchPath("") + "data" + System.getProperty("file.separator"); 
     //  or  dataFile(filename).toString();
  }

 //===========================================================
 //=== IBIO simplified input/output commands - GUI version ===
 //===========================================================

   public void output(String message)
   { javax.swing.JOptionPane.showMessageDialog(this,message); }

   public void outputString(String message)
   {  output(message);  }

   public void output(char info)
   {  output(info + ""); }

   public void output(byte info)
   {  output(info + ""); }

   public void output(int info)
   {  output(info + ""); }

   public void output(long info)
   {  output(info + ""); }
   
   public void output(float info)
   {  output(info + ""); }

   public void output(double info)
   {  output(info + ""); }

   public void output(boolean info)
   {  output(info + ""); }

   //----- Numerical input methods return 0 on error ------------

   public String input(String prompt)
   { return javax.swing.JOptionPane.showInputDialog(this,prompt); }

   public String inputString(String prompt)
   { return input(prompt);  }

   public String input()
   { return input("");     }

   public char inputChar(String prompt)
   { char result=(char)0;
     try{result=input(prompt).charAt(0);}
     catch (Exception e){result = (char)0;}
     return result;
   }

   public byte inputByte(String prompt)
   { byte result=0;
     try{result=Byte.valueOf(input(prompt).trim()).byteValue();}
     catch (Exception e){result = 0;}
     return result;
   }

   public int inputInt(String prompt)
   {  int result=0;
      try{result=Integer.valueOf(
                        input(prompt).trim()).intValue();}
      catch (Exception e){result = 0;}
      return result;
   }

   public long inputLong(String prompt)
   {  long result=0;
      try{result=Long.valueOf(input(prompt).trim()).longValue();}
      catch (Exception e){result = 0;}
      return result;
   }
   
   public float inputFloat(String prompt)
   {  float result=0;
      try{result=Float.valueOf(input(prompt).trim()).floatValue();}
      catch (Exception e){result = 0;}
      return result;
     
   }

   public double inputDouble(String prompt)
   {  double result=0;
      try{result=Double.valueOf(
                          input(prompt).trim()).doubleValue();}
      catch (Exception e){result = 0;}
      return result;
   }

   public boolean inputBoolean(String prompt)
   {  boolean result=false;
      try{result=Boolean.valueOf(
                         input(prompt).trim()).booleanValue();}
      catch (Exception e){result = false;}
      return result;
   }
         
  //============================================================
  //=========== end IBIO =======================================
  //============================================================

//== Added for Big Fonts in input and output dialogs ====

Object bigF = bigFonts();

public Object bigFonts()
{
  javax.swing.UIManager.put(
      "OptionPane.messageFont",
      new javax.swing.plaf.FontUIResource(new java.awt.Font("Verdana", java.awt.Font.BOLD, 24))
  );

  javax.swing.UIManager.put(
      "OptionPane.buttonFont",
      new javax.swing.plaf.FontUIResource(new java.awt.Font("Verdana", java.awt.Font.BOLD, 24))
  );

  javax.swing.UIManager.put(
      "TextField.font",
      new javax.swing.plaf.FontUIResource(new java.awt.Font("Verdana", java.awt.Font.BOLD, 24))
  );

  return null;
}   
  
