/*********************************************************
Susie is a school secretary. She keeps track of students and teachers
leaving school temporarily - to visit a doctor, a shop, etc.
She calls the list of missing people a "trip list".
She writes names and times on paper.  Sometimes a parent or friend
calls the school and wishes to contact someone.  If that person is 
out on a trip, Susie wants to know this quickly.  So she wants
a computer program that will look this up quickly.  This program uses
an ARRAY of OBJECTS to store the information about each trip.
Each OBJECT contains the name, times and reason for one trip.
At the end of the day, the program prints a list of all the trips.
**********************************************************/

class Trip        // stores several pieces of data for one trip
{
  String name = "";
  String reason = "";
  String leaveTime = "";
  String returnTime = "";
}

public class TripList
{
  Trip[] list = new Trip[1000]; // list of check-outs
  int count = 0;                // number of trips recorded in the list
  
  public TripList()
  {
    String person = "";
    do
    {
      person = input("Name");
      
      int found = -1;
      for(int c=0; c < count; c = c+1)
      {
        if(list[c].name.equals(person))
        {
          found = c;          
        } 
      }
      if(found >= 0)               // this person was already signed out
      { 
        output(person + "\n left at " + list[found].leaveTime 
                 + "\n and returned at " + list[found].returnTime
                 + "\n to " + list[found].reason);
        String now = input("Return time (blank if just checking)");
        list[found].returnTime = now;
      }
      else                         // this is a new check-out
      {
        Trip t = new Trip();
        t.name = person;
        t.leaveTime = input("Time now");
        t.reason = input("Reason");
        list[count] = t;                 // add new Trip to the list
        count = count + 1;               // count 1 more Trip
      }   
    } while(!person.equals("quit"));     // type "quit" to end the program
    
    for(int c=0; c < count-1; c = c+1)   // print the entire list
    {
      System.out.println(list[c].name);
      System.out.println("  left at " + list[c].leaveTime);
      System.out.println("  returned at " + list[c].returnTime);
      System.out.println("  to " + list[c].reason); 
    }
  }
  
  public static void main(String[] args)
  {  new TripList(); }
  
  public String input(String prompt)
  { return javax.swing.JOptionPane.showInputDialog(null,prompt); }
  
  public void output(String message)
  {  javax.swing.JOptionPane.showMessageDialog(null,message);  }
}
