/**************************************************\
WAITING QUEUE

This program inputs names and adds them to a QUEUE.
When the Leave button is clicked, it gets retrieves
the name from the HEAD of the queue and displays it.
This is useful for keeping a queue of names for
people waiting for a service, for example in a 
doctor's office.

\**************************************************/

public class WaitingQueue
{  
  String[] queue = new String[10];
  int head, tail;
  
  public WaitingQueue()
  {
     initialize();
     
     String command = "";
     while(true)
     {
        command = input("In/Out/Quit");
        command = command.toUpperCase();
        if(command.equals("IN"))
        {
           String newName = input("Type name to be added to the queue:");
           enqueue(newName); 
           display();
        }
        if(command.equals("OUT"))
        {
           String name = dequeue();
           output("Next person is " + name);  
           display();
        }
        if(command.equals("QUIT"))
        {
           System.exit(0); 
           display();
        }         
     }
  }
  
  void initialize()
  {
    head = 0;
    tail = -1;
  }
  
  void enqueue(String thisName)
  {
    tail = tail + 1;
    queue[tail] = thisName;
  }
  
  String dequeue()
  {
    if(head <= tail)
    {
      String name = queue[head];
      head = head + 1;
      return name;
    }   
    else
    {
      return "";
    }
  }
  
  void display()
  {
    String answer = "";
    for(int x = head; x <= tail; x = x+1)
    {
      answer = answer + queue[x] + "\n";
    }
    output(answer);
  }
  
  public static void main(String[] args)
  {  new WaitingQueue(); }
  
  public void output(String message)
  {  javax.swing.JOptionPane.showMessageDialog(null,message);  }
  
  public String input(String prompt)
  {  return javax.swing.JOptionPane.showInputDialog(null,prompt);  } 
}