/**************************************************\
WAITING QUEUE

This program inputs names and adds them to a QUEUE.
When the Leave button is clicked, it gets retrieves
the name from the HEAD of the queue and displays it.
This is useful for keeping a queue of names for
people waiting for a service, for example in a 
doctor's office.

\**************************************************/

import java.awt.*;

Button enter = new Button("Enter");
Button next = new Button("Next");
Button showAll = new Button("Show All");

String[] queue = new String[10];
int head, tail;
  
void setup()
{
   size(200,200);
   add(enter);
   add(next);
   add(showAll);
   initialize();
}

boolean action(java.awt.Event evt, Object src)
{
   Object source = evt.target; 
   if(source==enter)
   {
      String newName = input("Type name to be added to the queue:");
      enqueue(newName);
   }    
   if(source==next)
   {
      String name = dequeue();
      output("Next person is " + name);
   }
   if(source==showAll)
   { 
      display();
   }
   return true;
}
 
void initialize()
{
   head = 0;
   tail = -1;
}
 
void enqueue(String thisName)
{
   tail = tail + 1;
   queue[tail] = thisName;
}

String dequeue()
{
   if(head <= tail)
   {
      String name = queue[head];
      head = head + 1;
      return name;
   }   
   else
   {
      return "";
   }
}

void display()
{
   String answer = "";
   for(int x = head; x <= tail; x = x+1)
   {
       answer = answer + queue[x] + "\n";
   }
   output(answer);
}
 
public void output(String message)
{  javax.swing.JOptionPane.showMessageDialog(this,message);  }
   
public String input(String prompt)
{  return javax.swing.JOptionPane.showInputDialog(this,prompt);  } 
