/**************************************************
Emalia wants to collect eMail addresses in a list.
She starts with a program that inputs eMail addresses and
saves them in an array. Before adding the address to the array,
it VALIDATES by checking that it contains @ and . as required.
***************************************************/

public class Emails
{
  String[] addresses = new String[1000];
  
  int count = 0;        // the number of addresses in the array
  
  public Emails()
  {
    String email="";
    do
    {
      email = input("Type an eMail address (ENTER to quit)");
      if( isValid(email) )
      {
        addToAddresses(email);
        printAllAddresses();
      } 
      else
      {
        output(email + " is not valid");
      } 
    } while(email.length() > 0);      // type nothing to quit
  }
  
  boolean isValid(String email)  // check whether email is valid
  {
    if(email.length() < 5)        // shortest is a@b.c
    { return false; }   
    
    int atsign = email.indexOf("@");    // find the @ sign  
    if(atsign < 0 )                     
    { return false; }                   //  @ is missing
    
    String server = email.substring(atsign+1);  // the rest after @
    int dot = server.indexOf(".");              // find . in server
    
    if( dot < 0)                       
    { return false; }                   // . is missing
    
    return true;                  // if it got this far, it's valid                           
  }
  
  void addToAddresses(String email)
// pre-condition : COUNT contains number of items in the array
// post-condition: COUNT is 1 bigger and addresses[count] == email
  {
    addresses[count] = email;
    count = count + 1;
  }
  
  void printAllAddresses()
  {
    for(int c=0; c < count; c = c+1)
    {
      System.out.println(addresses[c]);
    } 
    System.out.println("============");
  }
  
  public static void main(String[] args)
  {  new Emails(); }
  
  public String input(String prompt)
  { return javax.swing.JOptionPane.showInputDialog(null,prompt); }
  
  public void output(String message)
  {  javax.swing.JOptionPane.showMessageDialog(null,message);  }
}