/************************************************************************\
NUMBERS LIST

This program creates an AWT GUI form,
inputs numbers, stores them in a list,
and then adds up all the numbers.

\************************************************************************/

import java.awt.*;
import javax.swing.*;

public class NumList extends Frame
{
  TextField numBox = new TextField("        ");
  Button b1 = new Button("Add to list");
  java.awt.List numList = new java.awt.List(10);
  Button b2 = new Button("Total");
  Button b3 = new Button("Quit");
  Font big = new Font("Arial",0,36);
  
  public NumList()
  {
    setLayout(new FlowLayout());
    setBounds(100,100,300,500);       // change size of standard window
    b1.setFont(big);     // change font on the Button b1
    b2.setFont(big);     // change font on Button b2
    numBox.setFont(big);
    numList.setFont(new Font("Arial",0,24));
    numBox.setText("");
    add(numBox);
    add(b1);             // display Button b1
    add(numList);
    add(b2);             // display Button b2
    add(b3);
  }
  
  public boolean action(java.awt.Event evt, Object src)
  {
    Object source = evt.target;      // this is the Button that was clicked
    
    if(source==b1)                  
    {
      String value = numBox.getText();  // copy text from TextField
      numList.add(value);               // copy number into numList
      numBox.setText("");               // clear the TextField
      numBox.requestFocus();            // move cursor to TextField
    }    
    
    if(source==b2)                       // [Total] Button
    {
      output(total());
    }
    
    if(source==b3)
    {
      System.exit(0); 
    }
    
    return true;
  }
  
  double total()
  {
    double sum = 0;
    int count = numList.getItemCount();     // count items in numList
    
    for(int c = 0; c < count; c = c+1)      // loop through all items
    {
      String value = numList.getItem(c);        // get item as String
      double num = Double.parseDouble(value);   // convert String to double
      sum = sum + num;                          // add to total
    }
    
    return sum;
  }

  public static void main(String[] args)
  {  (new NumList()).setVisible(true); }
  
   public void output(String message)
   {  javax.swing.JOptionPane.showMessageDialog(this,message);  }

   public void output(double info)
   {  output(info + ""); }

}
