import java.util.*;

void IOstart()
{
   boxFont = createFont("Arial",24); 
}

void showBoxes()
{
   for(Box b : boxes)
   {
      b.show();
   }
}

void checkBoxes()
{
   for(Box b : boxes)
   {
      b.isClicked();
   }  
}

void resetBox(String s)
{
   for(Box b : boxes)
   {
      if(b.tex.equals(s))
      {  b.inclick = false; }
   }   
}

void resetBox(Box b)
{
   b.inclick = false; 
}

boolean clickedBox(String s)
{
   for(Box b : boxes)
   {
      if(b.tex.equals(s))
      {  if(b.inclick)
         { return true; }
         else
         {return false;}
      }
   }   
   return false;
}

boolean clickedBox(Box b)
{
   if(b.inclick)
   { return true; }
   else
   { return false; }
}

class Box
{
    String tex = "";
    int left, top, width, height, red, green, blue,tred,tgreen,tblue;
    boolean inclick = false;
    PImage picture;
  
    public Box(String tex,int left, int top, int width, int height,
                 int red, int green, int blue)
    {
       this.tex = tex;
       this.left = left;
       this.top = top;
       this.width = width;
       this.height= height;
       this.red = red;
       this.green = green;
       this.blue = blue;
       boxes.add(this);
    }
    
    public Box(String tex, int left, int top)
    {
       this.tex = tex;
       this.left = left;
       this.top = top;
       this.width = tex.length()*20;
       this.height= 30;
       this.red = defGrey;
       this.green = defGrey;
       this.blue = defGrey;
       boxes.add(this);      
    }

    public Box(String tex,int left, int top, int width, int height)
    {
       this.tex = tex;
       this.left = left;
       this.top = top;
       this.width = width;
       this.height= height;
       this.red = defGrey;
       this.green = defGrey;
       this.blue = defGrey;
       boxes.add(this);
    }

    public Box(PImage pic,int left, int top, int width, int height)
    {
       this.tex = "";
       this.left = left;
       this.top = top;
       this.width = width;
       this.height= height;
       this.red = defGrey;
       this.green = defGrey;
       this.blue = defGrey;
       picture = pic;
       boxes.add(this);
    }    
    
    void setBackground(int r, int g, int b)
    {
       red = r;
       green = g;
       blue = b;
    }
    
    void setColor(int r, int g, int b)
    {
        tred = r;
        tgreen = g;
        tblue = b;
    }
    
    void setImage(PImage pic)
    {
       picture = pic; 
    }
    
    void setImage(String picName)
    {
       picture = loadImage(picName); 
    }

    public void setText(String t)
    {
       this.tex = t; 
    }
    
    public String getText()
    {
        return this.tex;
    }
    
    boolean mouseover()
    {
       return mouseOver(left,top,left+width,top+height);
    }
    
    void show()
    {
       if(mouseover())
       {
          fill(255);
       }
       else
       {
          fill(red,green,blue);
       }
       noStroke();
       if(picture==null)
       {
          rect(left,top,width,height);
       }
       else
       {
          image(picture,left,top,width,height); 
       }
       textFont(boxFont);
       fill(tred,tgreen,tblue);
       text(tex,left+5,top+height-5);
    }
    
    boolean isClicked()
    {
       if(inclick==false && mouseover() )
       {  inclick = true;
          return true;
       }
       else
       { inclick = false; 
         return false;
       }      
    }
    
    void reset()
    {
       inclick = false; 
    }
}

boolean mouseOver(int x1,int y1,int x2,int y2)
{
   if(mouseX >= x1 && mouseX <= x2 && mouseY >= y1 && mouseY <= y2)
   {
      return true; 
   }
   else
   {  return false; }
}

class TextBox
{
   java.awt.TextArea area ;
   java.awt.Frame window;
   
   public TextBox()
   {
       window = new java.awt.Frame();
       area = new java.awt.TextArea();
       area.setFont(new java.awt.Font("Arial",0,24));
       window.add(area);
       window.setBounds(100,100,300,600);
       window.setVisible(true);    
   }
   
   public TextBox(int left, int top, int width, int height)
   {
       window = new java.awt.Frame();
       area = new java.awt.TextArea();
       area.setFont(new java.awt.Font("Arial",0,24));
       window.add(area);
       window.setBounds(left,top,width,height);
       window.setVisible(true);    
   }
      
   
   public void clear()
   {
      area.setText(""); 
   }
   
   public void print(String s)
   {
      area.setText(area.getText() + s);
   }
   
   public void println(String s)
   {
      print(s + "\n"); 
   }
   
   public String getText()
   {
      return area.getText(); 
   }
   
   public void setText(String s)
   {
      area.setText(s);  
   }
   
   public void setBounds(int left, int top, int width, int height)
   {
      window.setBounds(left, top, width, height); 
   }
}

PFont boxFont;

int defGrey = 230;

Vector<Box> boxes = new Vector();

 //===========================================================
 //=== IBIO simplified input/output commands - GUI version ===
 //===========================================================


   public void outputString(String message)
   {  output(message);  }

   public void output(char info)
   {  output(info + ""); }

   public void output(byte info)
   {  output(info + ""); }

   public void output(int info)
   {  output(info + ""); }

   public void output(long info)
   {  output(info + ""); }

   public void output(double info)
   {  output(info + ""); }

   public void output(boolean info)
   {  output(info + ""); }

   //----- Numerical input methods return 0 on error ------------

   public String inputString(String prompt)
   { return input(prompt);  }

   public String input()
   { return input("");     }

   public char inputChar(String prompt)
   { char result=(char)0;
     try{result=input(prompt).charAt(0);}
     catch (Exception e){result = (char)0;}
     return result;
   }

   public byte inputByte(String prompt)
   { byte result=0;
     try{result=Byte.valueOf(input(prompt).trim()).byteValue();}
     catch (Exception e){result = 0;}
     return result;
   }

   public int inputInt(String prompt)
   {  int result=0;
      try{result=Integer.valueOf(
                        input(prompt).trim()).intValue();}
      catch (Exception e){result = 0;}
      return result;
   }

   public long inputLong(String prompt)
   {  long result=0;
      try{result=Long.valueOf(input(prompt).trim()).longValue();}
      catch (Exception e){result = 0;}
      return result;
   }

   public double inputDouble(String prompt)
   {  double result=0;
      try{result=Double.valueOf(
                          input(prompt).trim()).doubleValue();}
      catch (Exception e){result = 0;}
      return result;
   }

   public boolean inputBoolean(String prompt)
   {  boolean result=false;
      try{result=Boolean.valueOf(
                         input(prompt).trim()).booleanValue();}
      catch (Exception e){result = false;}
      return result;
   }
  //============================================================
  //=========== end IBIO =======================================
  //============================================================
  
  Object big = bigFonts();

public String input(String prompt)
{ return javax.swing.JOptionPane.showInputDialog(null,prompt); }

public void output(String message)
{ javax.swing.JOptionPane.showMessageDialog(null,message); }

public Object bigFonts()
{
javax.swing.UIManager.put(
"OptionPane.messageFont",
new javax.swing.plaf.FontUIResource(new java.awt.Font("Verdana", java.awt.Font.BOLD, 24))
);

javax.swing.UIManager.put(
"OptionPane.buttonFont",
new javax.swing.plaf.FontUIResource(new java.awt.Font("Verdana", java.awt.Font.BOLD, 24))
);

javax.swing.UIManager.put(
"TextField.font",
new javax.swing.plaf.FontUIResource(new java.awt.Font("Verdana", java.awt.Font.BOLD, 16))
);

return null;
}
 